#pragma once

#include <stdbool.h>

struct arguments {
  /** Path to the disk file that contains the start of the file we want to extract.
   * The file may stretch across multiple disks though.
   */
  char* diskName;
  /** Offset into the disk where the file starts. */
  unsigned long diskOffset;
  /** Size of the file stored in the disk. */
  unsigned long fileSize;
  //Decryption keys
  bool isEncrypted;
  //For xdelta3, the location of the old file
  char* prevFile;
  //Target file location where the extracted file is saved to
  char* target;
};


struct arguments parseArguments(int argc, char *argv[]);
